local explosion = true
local i = 0
local helper = require('scenario/scenariohelper')

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		TorqueScript.eval([[
			shockwave.setScale("150 150 0.1");
			shockwave.position = "-331.604 19.1809 86.8115";
		]])
		explosion = false
	end
end

local function onRaceWaypoint(data)
    if (data.waypointName == 'WayPoint1') then
        helper.flashUiMessage('Core overheating - nuclear meltdown imminent', 5)   
    elseif data.waypointName == 'WayPoint2' then
		helper.flashUiMessage('Reactor walls melted - nuclear meltdown triggered', 5)
		explosion = true
    end
end

local function onPreRender(dt)	
	if explosion then
		i = i+1
		local scale = i*15
		if scale < 5000 then
			TorqueScript.eval([[
					shockwave.setScale("]]..scale..[[ ]]..scale..[[ 0.1");
			]])
		end
		if i == 200 then
			TorqueScript.eval([[
				reactor1.position = "-64.4377 -24.0813 51.4281";
				reactor1.rotation = "-0.237598 -0.237317 -0.941928 93.4933";
				scenario_player1.position = "10.7014 -31.6991 90.8048";
				scenario_player2.position = "55.7336 -29.9373 86.4268";
				scenario_player3.position = "147.759 20.3799 174.606";
				scenario_player4.position = "249.431 49.4841 182.78";
				scenario_player5.position = "368.342 -60.7889 159.278";
			]])
			be:reloadStaticCollision();
		elseif i == 350 then
			TorqueScript.eval([[
				reactor8.position = "-14.1133 -11.9582 42.6359";
				reactor8.rotation = "-0.237598 -0.237317 -0.941928 93.4933";
			]])
			be:reloadStaticCollision();
		elseif i == 500 then
			TorqueScript.eval([[
				reactor2.position = "47.5712 -5.0002 53.8271";
				reactor2.rotation = "0 0 -1 90.0677";
			]])
			be:reloadStaticCollision();
		elseif i == 650 then
			TorqueScript.eval([[
				reactor3.position = "115.285 5.31112 37.0384";
				reactor3.rotation = "-0.585356 -0.0689563 0.807839 238.509";
			]])
			be:reloadStaticCollision();
		elseif i == 800 then
			TorqueScript.eval([[
				reactor4.position = "248.253 31.7381 56.8743";
				reactor4.rotation = "0 0 -1 90.0677";
			]])
			be:reloadStaticCollision();
		elseif i == 950 then
			TorqueScript.eval([[
				reactor5.position = "356.272 10.5356 41.2552";
				reactor5.rotation = "-0.318526 -0.0977881 0.942857 212.158";
			]])
			be:reloadStaticCollision();
		elseif i == 1100 then
			TorqueScript.eval([[
				reactor6.position = "364.892 -116.591 48.6347";
				reactor6.rotation = "0 0 -1 90.0677";
			]])
			be:reloadStaticCollision();
		elseif i == 1350 then
			TorqueScript.eval([[
				reactor7.position = "395.763 -162.04 48.2879";
				reactor7.rotation = "-0.455831 0.45637 -0.764163 105.294";
			]])
			helper.flashUiMessage('The bridge has been blocked!', 600)
			be:reloadStaticCollision();
		end
	end
end

return {
	onScenarioChange = onScenarioChange,
	onRaceWaypoint = onRaceWaypoint,
	onPreRender = onPreRender
}